import { CssProperty, InheritedCssProperty, Property, Style, View } from '@nativescript/core/ui/core/view';
import { Color } from '@nativescript/core/color';
export declare enum Transition {
    Fade = "fade",
    None = "none"
}
export declare enum Priority {
    Low = 0,
    Normal = 1,
    High = 2
}
export declare const srcProperty: Property<ImageCacheItBase, any>;
export declare const placeHolderProperty: Property<ImageCacheItBase, any>;
export declare const errorHolderProperty: Property<ImageCacheItBase, string>;
export declare const resizeProperty: Property<ImageCacheItBase, string>;
export declare const stretchProperty: Property<ImageCacheItBase, import("@nativescript/core/ui/image/image").Stretch>;
export declare const decodedWidthProperty: Property<ImageCacheItBase, number>;
export declare const decodedHeightProperty: Property<ImageCacheItBase, number>;
export declare const filterProperty: CssProperty<Style, string>;
export declare const transitionProperty: Property<ImageCacheItBase, Transition>;
export declare const fallbackProperty: Property<ImageCacheItBase, any>;
export declare const priorityProperty: Property<ImageCacheItBase, Priority>;
export declare const tintColorProperty: InheritedCssProperty<Style, string | Color>;
export declare const headersProperty: Property<ImageCacheItBase, Map<string, string>>;
export * from '@nativescript/core/ui/core/view';
export declare class ImageCacheItBase extends View {
    src: any;
    placeHolder: any;
    errorHolder: any;
    resize: string;
    stretch: Stretch;
    decodedHeight: number;
    decodedWidth: number;
    filter: string;
    transition: Transition;
    fallback: any;
    priority: Priority;
    get tintColor(): Color | string;
    set tintColor(value: Color | string);
    headers: Map<string, string>;
    static onLoadStartEvent: string;
    static onProgressEvent: string;
    static onErrorEvent: string;
    static onLoadEndEvent: string;
    _emitLoadStartEvent(url?: string): void;
    _emitProgressEvent(loaded: number, total: number, progress: number, url: string): void;
    _emitErrorEvent(message: string, url: string): void;
    _emitLoadEndEvent(url?: string, image?: any): void;
}
export declare type Stretch = 'none' | 'fill' | 'aspectFill' | 'aspectFit';
