"use strict";
function __export(m) {
    for (var p in m) if (!exports.hasOwnProperty(p)) exports[p] = m[p];
}
Object.defineProperty(exports, "__esModule", { value: true });
var view_1 = require("@nativescript/core/ui/core/view");
var color_1 = require("@nativescript/core/color");
var Transition;
(function (Transition) {
    Transition["Fade"] = "fade";
    Transition["None"] = "none";
})(Transition = exports.Transition || (exports.Transition = {}));
var Priority;
(function (Priority) {
    Priority[Priority["Low"] = 0] = "Low";
    Priority[Priority["Normal"] = 1] = "Normal";
    Priority[Priority["High"] = 2] = "High";
})(Priority = exports.Priority || (exports.Priority = {}));
exports.srcProperty = new view_1.Property({
    name: 'src'
});
exports.placeHolderProperty = new view_1.Property({
    name: 'placeHolder'
});
exports.errorHolderProperty = new view_1.Property({
    name: 'errorHolder'
});
exports.resizeProperty = new view_1.Property({
    name: 'resize'
});
exports.stretchProperty = new view_1.Property({
    name: 'stretch'
});
exports.decodedWidthProperty = new view_1.Property({
    name: 'decodedWidth'
});
exports.decodedHeightProperty = new view_1.Property({
    name: 'decodedHeight'
});
exports.filterProperty = new view_1.CssProperty({
    name: 'filter',
    cssName: 'filter'
});
exports.transitionProperty = new view_1.Property({
    name: 'transition',
    defaultValue: Transition.None
});
exports.fallbackProperty = new view_1.Property({
    name: 'fallback',
});
exports.priorityProperty = new view_1.Property({
    name: 'priority',
    defaultValue: Priority.Normal
});
exports.tintColorProperty = new view_1.InheritedCssProperty({
    name: 'tintColor',
    cssName: 'tint-color',
    equalityComparer: color_1.Color.equals, valueConverter: function (value) { return new color_1.Color(value); }
});
exports.headersProperty = new view_1.Property({
    name: 'headers'
});
__export(require("@nativescript/core/ui/core/view"));
var ImageCacheItBase = (function (_super) {
    __extends(ImageCacheItBase, _super);
    function ImageCacheItBase() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Object.defineProperty(ImageCacheItBase.prototype, "tintColor", {
        get: function () {
            return this.style.tintColor;
        },
        set: function (value) {
            if (typeof value === 'string') {
                this.style.tintColor = new color_1.Color(value);
            }
            else {
                this.style.tintColor = value;
            }
        },
        enumerable: true,
        configurable: true
    });
    ImageCacheItBase.prototype._emitLoadStartEvent = function (url) {
        this.notify({
            eventName: ImageCacheItBase.onLoadStartEvent,
            object: this
        });
    };
    ImageCacheItBase.prototype._emitProgressEvent = function (loaded, total, progress, url) {
        this.notify({
            eventName: ImageCacheItBase.onProgressEvent,
            object: this,
            loaded: loaded,
            total: total,
            progress: progress,
            url: url
        });
    };
    ImageCacheItBase.prototype._emitErrorEvent = function (message, url) {
        this.notify({
            eventName: ImageCacheItBase.onLoadStartEvent,
            object: this,
            message: message
        });
    };
    ImageCacheItBase.prototype._emitLoadEndEvent = function (url, image) {
        this.notify({
            eventName: ImageCacheItBase.onLoadEndEvent,
            object: this,
            image: image
        });
    };
    ImageCacheItBase.onLoadStartEvent = 'loadStart';
    ImageCacheItBase.onProgressEvent = 'progress';
    ImageCacheItBase.onErrorEvent = 'error';
    ImageCacheItBase.onLoadEndEvent = 'loadEnd';
    return ImageCacheItBase;
}(view_1.View));
exports.ImageCacheItBase = ImageCacheItBase;
exports.srcProperty.register(ImageCacheItBase);
exports.placeHolderProperty.register(ImageCacheItBase);
exports.errorHolderProperty.register(ImageCacheItBase);
exports.resizeProperty.register(ImageCacheItBase);
exports.stretchProperty.register(ImageCacheItBase);
exports.decodedHeightProperty.register(ImageCacheItBase);
exports.decodedWidthProperty.register(ImageCacheItBase);
exports.filterProperty.register(view_1.Style);
exports.transitionProperty.register(ImageCacheItBase);
exports.fallbackProperty.register(ImageCacheItBase);
exports.priorityProperty.register(ImageCacheItBase);
exports.tintColorProperty.register(view_1.Style);
exports.headersProperty.register(ImageCacheItBase);
//# sourceMappingURL=image-cache-it.common.js.map